rte_compressdev_pmd.h(3)

NAME
rte_compressdev_pmd.h

SYNOPSIS

#include <string.h>
#include <dev_driver.h>
#include 'rte_compressdev.h'
#include 'rte_compressdev_internal.h'

  Data Structures

struct rte_compressdev_global
struct rte_compressdev_ops

  Typedefs

typedef int(* compressdev_configure_t) (struct rte_compressdev *dev, struct rte_compressdev_config *config)
typedef int(* compressdev_start_t) (struct rte_compressdev *dev)
typedef void(* compressdev_stop_t) (struct rte_compressdev *dev)
typedef int(* compressdev_close_t) (struct rte_compressdev *dev)
typedef void(* compressdev_stats_get_t) (struct rte_compressdev *dev, struct rte_compressdev_stats *stats)
typedef void(* compressdev_stats_reset_t) (struct rte_compressdev *dev)
typedef void(* compressdev_info_get_t) (struct rte_compressdev *dev, struct rte_compressdev_info *dev_info)
typedef int(* compressdev_queue_pair_setup_t) (struct rte_compressdev *dev, uint16_t qp_id, uint32_t max_inflight_ops, int socket_id)
typedef int(* compressdev_queue_pair_release_t) (struct rte_compressdev *dev, uint16_t qp_id)
typedef int(* compressdev_stream_create_t) (struct rte_compressdev *dev, const struct rte_comp_xform *xform, void **stream)
typedef int(* compressdev_stream_free_t) (struct rte_compressdev *dev, void *stream)
typedef int(* compressdev_private_xform_create_t) (struct rte_compressdev *dev, const struct rte_comp_xform *xform, void **private_xform)
typedef int(* compressdev_private_xform_free_t) (struct rte_compressdev *dev, void *private_xform)

  Functions

struct rte_compressdev * rte_compressdev_pmd_get_named_dev (const char *name)

Detailed Description

RTE comp PMD APIs

Note
    These APIs are for comp PMDs only and user applications should not call them directly.

Definition in file rte_compressdev_pmd.h.

Typedef Documentation

  typedef int(* compressdev_configure_t) (struct rte_compressdev *dev, struct rte_compressdev_config *config)
Definitions of all functions exported by a driver through the generic structure of type comp_dev_ops supplied in the rte_compressdev structure associated with a device. Function used to configure device.

Parameters
    dev Compress device
    config Compress device configurations

Returns
    Returns 0 on success

Definition at line 80 of file rte_compressdev_pmd.h.

  typedef int(* compressdev_start_t) (struct rte_compressdev *dev)
Function used to start a configured device.

Parameters
    dev Compress device

Returns
    Returns 0 on success

Definition at line 91 of file rte_compressdev_pmd.h.

  typedef void(* compressdev_stop_t) (struct rte_compressdev *dev)
Function used to stop a configured device.

Parameters
    dev Compress device

Definition at line 99 of file rte_compressdev_pmd.h.

  typedef int(* compressdev_close_t) (struct rte_compressdev *dev)
Function used to close a configured device.

Parameters
    dev Compress device

Returns

    •   0 on success.

    •   EAGAIN if can't close as device is busy

Definition at line 110 of file rte_compressdev_pmd.h.

  typedef void(* compressdev_stats_get_t) (struct rte_compressdev *dev, struct rte_compressdev_stats *stats)
Function used to get statistics of a device.

Parameters
    dev Compress device
    stats Compress device stats to populate

Definition at line 121 of file rte_compressdev_pmd.h.

  typedef void(* compressdev_stats_reset_t) (struct rte_compressdev *dev)
Function used to reset statistics of a device.

Parameters
    dev Compress device

Definition at line 131 of file rte_compressdev_pmd.h.

  typedef void(* compressdev_info_get_t) (struct rte_compressdev *dev, struct rte_compressdev_info *dev_info)
Function used to get specific information of a device.

Parameters
    dev Compress device
    dev_info Compress device information to populate

Definition at line 142 of file rte_compressdev_pmd.h.

  typedef int(* compressdev_queue_pair_setup_t) (struct rte_compressdev *dev, uint16_t qp_id, uint32_t max_inflight_ops, int socket_id)
Setup a queue pair for a device.

Parameters
    dev Compress device
    qp_id Queue pair identifier
    max_inflight_ops Max inflight ops which qp must accommodate
    socket_id Socket identifier

Returns
    Returns 0 on success.

Definition at line 159 of file rte_compressdev_pmd.h.

  typedef int(* compressdev_queue_pair_release_t) (struct rte_compressdev *dev, uint16_t qp_id)
Release memory resources allocated by given queue pair.

Parameters
    dev Compress device
    qp_id Queue pair identifier

Returns

    •   0 on success.

    •   EAGAIN if can't close as device is busy

Definition at line 173 of file rte_compressdev_pmd.h.

  typedef int(* compressdev_stream_create_t) (struct rte_compressdev *dev, const struct rte_comp_xform *xform, void **stream)
Create driver private stream data.

Parameters
    dev Compressdev device
    xform xform data
    stream ptr where handle of pmd's private stream data should be stored

Returns

    •   Returns 0 if private stream structure has been created successfully.

    •   Returns -EINVAL if input parameters are invalid.

    •   Returns -ENOTSUP if comp device does not support STATEFUL operations.

    •   Returns -ENOTSUP if comp device does not support the comp transform.

    •   Returns -ENOMEM if the private stream could not be allocated.

Definition at line 192 of file rte_compressdev_pmd.h.

  typedef int(* compressdev_stream_free_t) (struct rte_compressdev *dev, void *stream)
Free driver private stream data.

Parameters
    dev Compressdev device
    stream handle of pmd's private stream data

Returns

    •   0 if successful

    •   <0 in error cases

    •   Returns -EINVAL if input parameters are invalid.

    •   Returns -ENOTSUP if comp device does not support STATEFUL operations.

    •   Returns -EBUSY if can't free stream as there are inflight operations

Definition at line 209 of file rte_compressdev_pmd.h.

  typedef int(* compressdev_private_xform_create_t) (struct rte_compressdev *dev, const struct rte_comp_xform *xform, void **private_xform)
Create driver private_xform data.

Parameters
    dev Compressdev device
    xform xform data
    private_xform ptr where handle of pmd's private_xform data should be stored

Returns

    •   if successful returns 0 and valid private_xform handle

    •   <0 in error cases

    •   Returns -EINVAL if input parameters are invalid.

    •   Returns -ENOTSUP if comp device does not support the comp transform.

    •   Returns -ENOMEM if the private_xform could not be allocated.

Definition at line 229 of file rte_compressdev_pmd.h.

  typedef int(* compressdev_private_xform_free_t) (struct rte_compressdev *dev, void *private_xform)
Free driver private_xform data.

Parameters
    dev Compressdev device
    private_xform handle of pmd's private_xform data

Returns

    •   0 if successful

    •   <0 in error cases

    •   Returns -EINVAL if input parameters are invalid.

    •   Returns -EBUSY if can't free private_xform due to inflight operations

Definition at line 245 of file rte_compressdev_pmd.h.

Function Documentation

  struct rte_compressdev * rte_compressdev_pmd_get_named_dev (const char * name)
Get the rte_compressdev structure device pointer for the named device.

Parameters
    name Compress device name

Returns

    •   The rte_compressdev structure pointer for the given device identifier.

Author

Generated automatically by Doxygen for DPDK from the source code.